﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Charting;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ChartView;

namespace TemplateselectorTest
{
    public class DateTimeAxisLabelTemplateSelector : DataTemplateSelector
    {
        public DataTemplate Template1 { get; set; }

        public DataTemplate Template2 { get; set; }

        public DataTemplate Template3 { get; set; }

        static Dictionary<CategoricalAxis, List<string>> _cacheLabels = new Dictionary<CategoricalAxis, List<string>>();
        static Dictionary<DateTimeContinuousAxis, List<string>> _cacheLabels_1 = new Dictionary<DateTimeContinuousAxis, List<string>>();

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var model = item as AxisLabelModel;
            
            {
                var axis = container as DateTimeContinuousAxis;

                var dataContext = axis.Chart.DataContext;


                if (!_cacheLabels_1.ContainsKey(axis))
                {
                    _cacheLabels_1.Add(axis, new List<string>());
                }

                if (model.CollectionIndex < 2)
                {
                    _cacheLabels_1[axis].Clear();
                }

                DataTemplate template = Template1;
                if (true)
                {
                    template = Template3;
                    var span = ((((Telerik.Windows.Controls.RadCartesianChart)(axis.Chart)).HorizontalAxis as DateTimeContinuousAxis).ActualVisibleRange.Maximum - (((Telerik.Windows.Controls.RadCartesianChart)(axis.Chart)).HorizontalAxis as DateTimeContinuousAxis).ActualVisibleRange.Minimum);
                    var minYear = (((Telerik.Windows.Controls.RadCartesianChart)(axis.Chart)).HorizontalAxis as DateTimeContinuousAxis).ActualRange.Minimum.Year;
                    var maxYear = (((Telerik.Windows.Controls.RadCartesianChart)(axis.Chart)).HorizontalAxis as DateTimeContinuousAxis).ActualRange.Maximum.Year;
                    List<int> YearsList = new List<int>();
                    for (int i = minYear; i <= maxYear; i++)
                    {
                        YearsList.Add(i);
                    }

                    var count = (((Telerik.Windows.Controls.RadCartesianChart)(axis.Chart)).Series[0] as LineSeries).DataPoints.Count;
                    if (span.TotalDays < 600)
                    {
                        return Template1;
                    }

                    var YearsCount = span.TotalDays / 365;
                    var MonthsCount = (int)Math.Ceiling(YearsCount * 12);
                    var ticksCount0 = YearsCount;

                    int thinFactor0 = 0;
                    try
                    {
                        thinFactor0 = (int)Math.Floor((27 * (ticksCount0 + 1) / axis.Chart.PlotAreaClip.Width));//series.Chart.GetVisualParent<RadPaneGroup>().ActualWidth));
                    }
                    catch (Exception)
                    {

                    }

                    if (((System.DateTime)(model.Content)).Date.Month == 1 && !_cacheLabels_1[axis].Contains(((System.DateTime)(model.Content)).Date.ToString("yyyy")))
                    {
                        _cacheLabels_1[axis].Add(((System.DateTime)(model.Content)).Date.ToString("yyyy"));
                        if (thinFactor0 != 0)
                        {
                            var index0 = YearsList.IndexOf(((System.DateTime)(model.Content)).Date.Year);
                            if (index0 % (thinFactor0 + 1) != 0)
                            {
                                return Template2;
                            }
                            else
                            {
                                return Template3;
                            }
                        }
                        else


                            return Template3;
                    }
                    else
                    {

                        template = Template2;
                    }

                }
                

                if (_cacheLabels_1[axis].Contains(model.Content.ToString()))
                {

                    template = Template2;
                }
                else
                {
                    if (_cacheLabels_1[axis].Count == 0)
                        template = Template2;
                    
                    _cacheLabels_1[axis].Add(model.Content.ToString());

                }
                return template;
            }




        }
    }
}
